# NyaaPantsu android app [![Build Status](https://travis-ci.org/NyaaPantsu/NyaaPantsu-android-app.svg?branch=master)](https://travis-ci.org/NyaaPantsu/NyaaPantsu-android-app)

Android app built for NyaaPantsu

## Build
Clone the git repo
`git clone https://github.com/NyaaPantsu/NyaaPantsu-android-app.git`

Build with gradle:
`cd NyaaPantsu-android-app & ./gradlew clean build`

You'll find the unsigned apk in ___/app/build/outputs/apk/releases/___

## Contributing
You can contribute by forking this repo and making a pull request. Please do understand that this is a side project, therefore the review might take a little longer.

## Improving/adding translations
There are two possibilities:

### With Android Studio (easier)
You can translate the app easily with the translation editor in Android Studio. First, clone the repo and open it with Android Studio (version >=3). Once you are done, you just need to pull request the changed files.

### By XML
If you want to edit or add a translation, you must know the androidLanguageCode of your language. The list can be found [here](https://github.com/championswimmer/android-locales).

To edit, go to ___/app/src/main/res/values-___ {androidLanguageCode} and download `strings.xml`. Each of the translations are inside a string xml tag with a __name__ attribute which corresponds to the string id. The __name__ attribute must be the same in every language. When adding a new tag with a new __name__ attribute, you have to add its english couterpart in ___/app/src/main/res/values/strings.xml___, so every translator can know which translation they are missing.

To add a new language, you have to download ___/app/src/main/res/values/strings.xml___, translate every piece of text inside xml tag and you mustn't touch to the attribute __name__! When you have done that, create a new folder in ___/app/src/main/res/___ named `values-{androidLanguageCode}` and upload your translated strings.xml in that folder.

As you can see, there is already a translation for en-rUS. You can see how it works.

## Disclaimer
We take no legal responsibility for anything this code is used for. This is purely an educational proof of concept.
